using System;
using System.Text.RegularExpressions;
using System.Collections.Specialized;
using System.Collections.Generic;


#pragma warning disable 1591
#warning 1591 disabled

namespace Ivony
{
  public static class FormatUtility
  {
    public static readonly Regex FormatRegex = new Regex( @"\{((?<index>[0-9]+)\#)?(?<name>[a-zA-Z_][a-zA-Z0-9_]*)(,(?<alignment>[0-9]+[a-zA-Z]*))?(\:(?<format>[^{}]*))?\}", RegexOptions.Compiled );
    public static readonly Regex FormatRegexNum = new Regex( @"\{(?<index>[0-9]*)(,(?<alignment>[0-9]+[a-zA-Z]*))?(\:(?<format>[^{}]*))?\}", RegexOptions.Compiled );

    /// <summary>
    /// ػ񶨳ַ
    /// </summary>
    /// <param name="source">Դַ</param>
    /// <param name="length">Ҫػĳ</param>
    /// <returns>ػַ</returns>
    static public string FixLenth( string source, int length )
    {
      return FixLenth( source, length, "..." );
    }
    /// <summary>
    /// ػ񶨳ַ
    /// </summary>
    /// <param name="source">Դַ</param>
    /// <param name="length">Ҫػĳ</param>
    /// <param name="postfix">ַض̣Ҫʲôĺ׺</param>
    /// <returns>ػַ</returns>
    static public string FixLenth( string source, int length, string postfix )
    {
      if ( source == null )
        throw new ArgumentNullException( "source" );
      if ( postfix == null )
        postfix = "...";



      int postfixLength = System.Text.Encoding.GetEncoding( "GB2312" ).GetByteCount( postfix );
      int srcLength = System.Text.Encoding.GetEncoding( "GB2312" ).GetByteCount( source );

      if ( length < postfixLength )
        throw new ArgumentOutOfRangeException( "length" );

      if ( srcLength > length )
      {
        for ( int i = source.Length; i > 0; i-- )
        {
          srcLength = System.Text.Encoding.GetEncoding( "GB2312" ).GetByteCount( source.Substring( 0, i ) );

          if ( srcLength <= length - postfixLength )
            return source.Substring( 0, i ) + postfix;
        }
        return "";
      }
      else
        return source;
    }

    /// <summary>
    /// ЭӦöʽ
    /// </summary>
    /// <param name="str">Դַ</param>
    /// <param name="alignment">ʽַ</param>
    /// <returns>Ӧøʽַ</returns>
    public static string ApplyAlignment( string str, string alignment )
    {
      if ( str == null )
        throw new ArgumentNullException( "str" );
      if ( alignment == null )
        throw new ArgumentNullException( "alignment" );


      if ( alignment.EndsWith( "f" ) )
        return FixLenth( str, int.Parse( alignment.Substring( 0, alignment.Length - 1 ) ) );
      else
        return str;
    }

    /// <summary>
    /// Эʽһ
    /// </summary>
    /// <param name="obj"></param>
    /// <param name="formatstring">ʽַ</param>
    /// <param name="aligment">ʽַ</param>
    /// <returns>ʽ</returns>
    public static string FormatObject( object obj, string formatstring, string aligment )
    {
      if ( obj == null )
        throw new ArgumentNullException( "obj" );


      IFormattable formattable = obj as IFormattable;
      string result;
      if ( formattable != null )
        result = formattable.ToString( formatstring, null );
      else
        result = obj.ToString();

      return ApplyAlignment( result, aligment );
    }
  }
}
