﻿using System;
using System.Collections.Generic;
using System.Text;

namespace Ivony.Data.SqlDom
{
  /// <summary>
  /// 所有参数表达式的基类
  /// </summary>
  public class ParameterExpression : SqlExpression
  {
    private string _name;

    public string Name
    {
      get { return _name; }
    }


    private object _value;

    public object Value
    {
      get { return _value; }
    }

    public ParameterExpression( object value ) : this( null, value ) { }

    public ParameterExpression( string name, object value )
    {
      _name = name;
      _value = value;
    }

    internal static ParameterExpression[] CreateArray( Array array )
    {
      if ( array.Rank != 1 )
        throw new ArgumentException( "array" );

      if ( array == null )
        throw new ArgumentNullException( "array" );


      ParameterExpression[] parameters = new ParameterExpression[array.Length];

      for ( int i = 0; i < array.Length; i++ )
        parameters[i] = new ParameterExpression( array.GetValue( i ) );

      return parameters;
    }
  }
}
